Projects
--------

### How do I download projects from the Perforce Workshop? Do I need a registered account?

You do not need a registered account to download anything from the
Perforce Workshop.

Most project pages will have convenient links that you can click to
download relevant project files. If a project does not have a wiki page
yet but you know what depot guest branch it's in, you can use to look
for it on the web, or you can browse for it with any Perforce client
application running on your machine, using the **sync** command to
download files.

See [How to Browse](How_to_Browse "wikilink") for more information on
browsing the Perforce Workshop.

### How do I track changes to a project I am interested in?

There are two ways to track changes to projects that interest you.

If you prefer RSS feeds, the [P4Web](http://public.perforce.com:8080)
that runs against the Workshop Perforce server can generate RSS feeds of
change history for any path in the depot. To get the RSS feed for a
given path in P4Web:

1.  In the files tab of P4Web, browse to the path you are interested in
    by clicking the path links
2.  At the top of the window click on the Submitted tab
3.  The RSS feed link will be on the right side of the window, close to
    the top

If you prefer email, you can get change notifications via the review
daemon that runs against the Perforce Workshop. To setup email review
for a given path:

1.  In your favorite Perforce client, open up your user specification.
    In P4V you can edit the current user by going to Connection | Edit
    Current User... in the menu. From the command line run *p4 user*.
2.  In the reviews field enter the paths you are interested in, one
    per line. For example if you wanted to setup reviews for all guest
    branches you would use **//guest/...**. All standard Perforce
    wildcards are usable in review paths.

RSS feeds and a list of recent changes can also frequently be found on
the project page for any given project.

Guest Branches
--------------

### Where is my guest branch? I can't find it.

When you register for the Perforce Workshop you are given write
permission to the path "`//guest/your_name/...`", but until you add
files to this path, it won't show up in the depot.

The guest branch directory will be created automatically as soon as
you've added files to it. See [Adding
Files](http://www.perforce.com/perforce/doc.current/manuals/p4guide/04_files.html#1069361)
in the P4 User's Guide for more information on adding files to a
Perforce depot.

### How do I work on a project in someone else's guest branch?

You only have **write** permissions to your own guest branch, but you
can integrate anything into it that you can **read**, which is
everything in the `//public` and `//guest` depots). This means that you
can integrate a project from another user's guest branch into your own
and make any edits to it that you like without impacting the other
user's files.

If someone else has been working on one of your projects in their guest
branch and you like their changes, you can integrate from their branch
back into your branch to merge the changes together.

Contributors
------------

### How do I add a page to a category?

Add the following text to the page:

`[[Category:`*`CATEGORY` `NAME`*`]]`

When you save or preview the page, you will see the new category listed
in the category links box at the bottom of the page. If it's a new
category, the link will be in red to indicate that the linked page does
not exist yet.

**It is usually better to add a page to an existing general category
than to create a new category that contains only one or two pages.**

If you do add a new category, make sure to in turn add your new category
to an existing category that it is a subset of. For example, suppose
that you've written a handful of Half-Life mods for Perforce, and you
want to create a new category to put them all under; you might create a
new category called "Perforce Half-Life modifications". You would then
click on the link to this new category to edit it and add the text
`<nowiki>[[</nowiki>Category:Perforce integrations]]` to make your new
category a subcategory under [:Category:Perforce
integrations](:Category:Perforce_integrations "wikilink").

See [Help:Categories at
mediawiki.org](http://www.mediawiki.org/wiki/Help:Categories) and [Using
Categories](Using_Categories "wikilink") on this wiki for more
information on MediaWiki categories.

### How do I use templates?

Templates are special MediaWiki pages that can be included in other
pages. They're handy for centralizing frequently used and/or complex
page elements. Some templates can accept parameters (like a function in
a programming language) that affect their output; simpler templates do
not accept parameters and always produce the same output.

The syntax for using a template is:

`{{TemplateName|param1|param2|...}}`

The template's output will be automatically placed into the page at the
point where the template was used.

We have created a number of templates designed to make creating project
pages easier. Most of these templates, particularly the complex ones,
will have usage information on the template page itself. See
<Template:Project> for an example. The [project page
boilerplate](How_to_Contribute#Creating_Project_Pages "wikilink") in the
[How to Contribute](How_to_Contribute "wikilink") page consists mostly
of templates that create common project page elements when given
important pieces of project information as parameters.

Although using templates that we've made makes a lot of things easier,
you're also free to make pages entirely from scratch, or to make your
own templates. Most of our templates are protected so that they can't be
edited, but you can see how they're implemented by going to the template
pages and clicking "view source".

See [Help:Templates at
mediawiki.org](http://www.mediawiki.org/wiki/Help:Templates) and [Using
Templates](Using_Templates "wikilink") on this wiki for more information
on MediaWiki templates.

### How do I make my page look like this other one?

If you see a project page that you like the look of and you want your
own project pages to emulate it, you can view the source by clicking the
**edit** link (or **view source** if it's a protected page). This will
show you all of the markup, templates, et cetera that the page uses,
which will make it easy to mimic the layout in your pages.
Alternatively, you can just copy and paste it into your page (changing
all of the relevant details, of course).

If you get stuck on what exactly a particular piece of wiki markup
means, refer to the [help
pages](http://www.mediawiki.org/wiki/Help:Contents) at mediawiki.org. If
you're having trouble with a particular template, you can go directly to
that template's page to see if there are any usage notes (or view its
source if necessary). Links to the templates used in a page are
displayed whenever you view that page's source.

<Category:Administrative>
